clear;
close all;


%% Initialisation
 
global prod unr f_q s_q wage vac tightness
global r T N M draw tau k alpha burn b0
global B C z0
% global nu mu s phi rho sig

N=150;
M=500;

r=0.05/4; % discount rate 5pct annual
alpha = 0.5;
tau=.5;
k=0.12 ;


% productivity process
dta = importdata('/Users/jean-marcrobin/Documents/RECHERCHE/macrodyn/stata/work/USquarterly.raw');% BLS data
dta=dta(isnan(dta(:,1))==0,:);
dta=dta(isnan(dta(:,4))==0,:);
% dta=dta(dta(:,8)>=1988,:);
prod=dta(:,1);
prod=prod/mean(prod);
T=length(prod);
wage=dta(:,2); 
unr=dta(:,3);
vac=dta(:,4);
tightness=dta(:,5);
f_q=dta(:,6);
s_q=dta(:,7);

% calculate moments

X=[prod unr s_q f_q ];

Me=mean(X);
Sd=std(log(X));
kurt=kurtosis(log(X));
Co=corr(log(X));
elas_x=Co(1,:).*Sd/Sd(1); 
rhox = regress(log(prod(2:T)),[ones(T-1,1) log(prod(1:T-1))]);

b0=[ Me(1); Sd(1); rhox(2); Me(2); Sd(2); kurt(2);  Me(4)];

logit=@(x) 1/(1+exp(x));

load x0;
b=x0;
nu=exp(b(1))
mu=exp(b(2))
s=logit(b(3))
phi=logit(b(4))
rho=tanh(b(5))
sig=exp(b(6))
z0=exp(b(7))
C=exp(b(8))
B=1


T=5000;
burn=1000;
draw=rand(burn+T,1); 


%% Estimation


loginv=@(x) log(1./x-1);
logit=@(x) 1./(1+exp(x));

x0=[log(nu);log(mu);loginv(s);loginv(phi);atanh(rho);log(sig)...
    ;log(z0);log(C)];
    
for i=1:3
    options =optimset('TolX',1e-4,'Display','iter','MaxFunEvals',100000,...
    'MaxIter',100,'DiffMaxChange',1e-4);

[b,feval,exitflag] = fminsearch(@(b) estTurnoverCrit2(b),x0,options)
x0=b;
save('x0','x0')

nu=exp(b(1))
mu=exp(b(2))
s=logit(b(3))
phi=logit(b(4))
rho=tanh(b(5))
sig=exp(b(6))
z0=exp(b(7))
C=exp(b(8))

end

