/**************************************************************************************
Estimate elasticities of rates wrt unemployment and matching function at monthly freq.
***************************************************************************************/

clear
use "jolts_unemployment_help_work_m"

****************
* elasticities
****************


g lqur=ln(qur)
g lf=log(f)
g ljfr=ln(jfr)
g ls=log(s)
g lldr=ln(ldr)
g lur=ln(ur)
reg ljfr lur
reg lf lur
reg lf lur if time>=ym(2000,12)
reg lqur lur
reg lldr lur
reg ls lur
reg ls lur if time>=ym(2000,12)



********************
* Matching function
********************


global tau=0.5
g k=qur/f/$tau
su k,det
global kappa=r(mean)
tw (sc k ur, c(l)) (lfit k ur), legend(off) ytitle(k) 
gr export "figures/k_m.eps", replace

*global kappa=0
cap drop theta ltheta
g theta=v/(ur+$kappa*(1-ur))
lab var theta "tightness"
g ltheta=ln(theta)

reg lf ltheta
predict ljfrpred
predict ljfrres, resid
tw (sc lf ltheta, c(l) ) (lfit lf ltheta), legend(off) ytitle(log unemp. exit rate) xtitle(log tightness) 
gr export "figures/matching_fit.eps", replace

g jfrpred=exp(ljfrpred)
lab var jfrpred "Fitted values"
g qurpred=jfrpred*$kappa*$tau
lab var qurpred "Fitted values"

tw (tsline f, ysc(log)) (tsline jfrpred,ysc(log) lpattern("-")) if time>ym(2000,12) 
tw (tsline f, ysc(log)) (tsline jfrpred,ysc(log) lpattern("-"))  
gr export "figures/jfr_fit.eps",replace

tw (tsline qur, ysc(log)) (tsline qurpred,ysc(log) lpattern("-")) if time>=ym(2000,12)
gr export "figures/qur_fit.eps",replace

g teta=v/ur
sc ur v, ysc(log) xsc(log) c(l)
sc ur theta, ysc(log) xsc(log) c(l) 
sc ur teta, ysc(log) xsc(log) c(l) 
sc ur s, ysc(log) xsc(log) c(l)     
sc ur f, ysc(log) xsc(log) c(l)    
sc s f, ysc(log) xsc(log) c(l)    


